<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-user](./foundation-user.md) &gt; [User](./foundation-user.user.md)

## User interface

User interface.

**Signature:**

```typescript
export interface User extends UserPathHistory, UserActionHistory 
```
**Extends:** [UserPathHistory](./foundation-user.userpathhistory.md)<!-- -->, [UserActionHistory](./foundation-user.useractionhistory.md)

## Remarks

The user singleton, which always exists in either an anonymous or authenticated mode.

## Example


```ts
import { User } from '@genesislcap/foundation-user';
...
@User private user: User
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [details](./foundation-user.user.details.md) | <code>readonly</code> | [SetUserProperties](./foundation-user.setuserproperties.md)<!-- -->\['details'\] |  |
|  [isAnonymous](./foundation-user.user.isanonymous.md) | <code>readonly</code> | boolean |  |
|  [isAuthenticated](./foundation-user.user.isauthenticated.md) | <code>readonly</code> | boolean |  |
|  [permission](./foundation-user.user.permission.md) | <code>readonly</code> | string\[\] |  |
|  [profile](./foundation-user.user.profile.md) | <code>readonly</code> | string\[\] |  |
|  [rawProperties](./foundation-user.user.rawproperties.md) | <code>readonly</code> | Partial&lt;[SetUserProperties](./foundation-user.setuserproperties.md)<!-- -->&gt; | A structuredClone of the raw unmanaged properties used to set the user. |
|  [sourceRef](./foundation-user.user.sourceref.md) | <code>readonly</code> | string |  |
|  [userKVs](./foundation-user.user.userkvs.md) | <code>readonly</code> | { \[key: string\]: any; } |  |
|  [username](./foundation-user.user.username.md) | <code>readonly</code> | string |  |
|  [userName](./foundation-user.user.username.md) | <code>readonly</code> | string |  |

## Methods

|  Method | Description |
|  --- | --- |
|  [addAuthenticationChangeListener(listener)](./foundation-user.user.addauthenticationchangelistener.md) |  |
|  [clearTrackingHistory()](./foundation-user.user.cleartrackinghistory.md) |  |
|  [hasPermission(permission)](./foundation-user.user.haspermission.md) |  |
|  [hasProfile(profile)](./foundation-user.user.hasprofile.md) |  |
|  [isAdmin()](./foundation-user.user.isadmin.md) |  |
|  [isBanned()](./foundation-user.user.isbanned.md) |  |
|  [set(properties)](./foundation-user.user.set.md) |  |
|  [unset()](./foundation-user.user.unset.md) |  |

